#Written by Abhijay Thammana
import csv
import unicodedata
import numpy as np
import re

def getstuff(filename):
    # opening a csv to read it and write it
    with open(filename, "r", encoding="utf8") as csvfile, open("Scored Filtered 2017 Data.csv", "w", newline='', encoding='utf8') as writefile:
        data = csv.reader(csvfile)
        dataWriter = csv.writer(writefile)
        # yield next(data)  # yield the header row
        count = 0
        headers = next(data)
        #going through each row of the data
        for row in data:
            if count == 0:
                row.append('Bird Score')
            else:
                #uses arbitrary weights to measure bird life knowledge
                birdScore = calcBirdScore(row) #22 - tui, 28 - saddleback, 34 - kereru, 40 - kaka #Native: quail - 17, kakariki - 18, hihi - 19, sparrow - 20
                row.append(birdScore)
                print(birdScore)

            dataWriter.writerow(row)
            # print(row)
            # birdScore = calcBirdScore(row) #22 - tui, 28 - saddleback, 34 - kereru, 40 - kaka
            # print(birdScore)
            count += 1
            # if count > 5:
                # return

def refineAnswer(ans):
    return re.sub('[^0-9a-zA-Z]+', ' ', unicodedata.normalize('NFKD', ans).encode('ASCII', 'ignore').decode("utf-8").lower())
        # row.append()

def calcBirdScore(row):
    #number to return
    birdScore = 0
    #finds the answer from the row in the csv and then removes any macrons and makes it lowercase
    tuiAnswer = refineAnswer(row[5])
    saddlebackAnswer = refineAnswer(row[10])
    sparrowAnswer = refineAnswer(row[15])
    kakaAnswer = refineAnswer(row[20])

    #adds arbitrary numbers based on the question

    #Identified birds nativity
    if row[6] == 'Yes': birdScore += 4
    if row[11] == 'Yes': birdScore += 4
    if row[16] == 'No': birdScore += 4
    if row[21] == 'Yes': birdScore += 4

    #adds depending on whether they identify it right (includes spelling errors and alternate spellings (levenshtein distance was not implemented))
    if 'tui' in tuiAnswer or 'parson' in tuiAnswer or 'tiu' in tuiAnswer: birdScore += 7
    if 'saddl' in saddlebackAnswer or 'tiek' in saddlebackAnswer: birdScore += 10
    if 'spar' in sparrowAnswer or 'sparrow' in sparrowAnswer: birdScore += 8
    if 'kaka' in kakaAnswer or 'parrot' in kakaAnswer: birdScore += 9

    #ghost code
    print(row[6], row[11], row[16], row[21] + ', ' + tuiAnswer + ', ' + saddlebackAnswer + ', ' + sparrowAnswer + ', ' + kakaAnswer + ', ' + str(birdScore))
    return birdScore


getstuff("Copy of Filtered 2017 Data.csv")
